/**
 *
 */
package modeles;

import java.util.*;

public class Labyrinthe {
	protected List<Personnage> listePersonnage=new ArrayList<Personnage>();
	protected List<Arme> listeArme= new ArrayList<Arme>();
	protected List<Armure> listeArmure=new ArrayList<Armure>();
	protected List<Porte> listePorte=new ArrayList<Porte>();
	protected List<Monstre> listeMonstre=new ArrayList<Monstre>();

	public Labyrinthe() {
		/*switch (nInstance)
	case 1 :
			return Labyrinthe1();
			break;
		}*/
		labyrinthe1();
	}
	public void labyrinthe1() {
		Arme arme=new Arme("Epee en bois",25,10,2);
		listeArme.add(arme);
		Arme arme1=new Arme("Epee en acier",100,10,4);
		listeArme.add(arme1);
		Arme arme2=new Arme("Epee en acier solide",200,20,4);
		listeArme.add(arme2);
		Arme arme3=new Arme("Epee de cristal",150,5,7);
		listeArme.add(arme3);
		Arme arme4=new Arme("Lame Blanche",500,30,10);
		listeArme.add(arme4);

		Armure armure1=new Armure("armure de cuir",70,10,5);
		listeArmure.add(armure1);
		Armure armure=new Armure("armure en papier",30,5,2);
		listeArmure.add(armure);
		Armure armure2=new Armure("armure de fer",100,10,5);
		listeArmure.add(armure2);
		Armure armure3=new Armure("Le kevlar",300,15,8);
		listeArmure.add(armure3);

		Personnage perso=new Personnage("Aramis",10,1);
		listePersonnage.add(perso);
		Personnage perso2=new Personnage("Boromis",8,2);
		listePersonnage.add(perso2);

		Monstre mons = new Monstre("pantin en bois",5, 1);
		Monstre mons2= new Monstre("araignee geante agressive", 7, 5);
		Monstre mons3=new Monstre("pantin de fer",40,1);
		Monstre mons4 = new Monstre("Golem de Jade",40, 3);
		Monstre mons5 = new Monstre("Neltharion le Gardeterre",100,10);
		Monstre mons6 = new Monstre("Neltharion, le Destructeur", 80,20);

		this.listeMonstre.add(mons);
		this.listeMonstre.add(mons2);
		this.listeMonstre.add(mons3);
		this.listeMonstre.add(mons4);
		this.listeMonstre.add(mons5);
		this.listeMonstre.add(mons6);

		Marche marche = new Marche();

		List<Integer>table=new ArrayList<Integer>();
		Random rd= new Random();
		for (int i = 0; i<rd.nextInt(this.listeMonstre.size());i++) {
			table.add(rd.nextInt(this.listeMonstre.size()-3));
		}
		Salle salle1 = new Salle(1,0,false,table);
		Porte po = new Porte(true,marche,salle1);
		listePorte.add(po);

		List<Integer>table2=new ArrayList<Integer>();
		for (int i = 0; i<rd.nextInt(this.listeMonstre.size());i++) {
			table2.add(rd.nextInt(this.listeMonstre.size()-3));
		}
		Salle salle2 = new Salle(0,1,false, table2);
		Porte po2= new Porte(true,marche,salle2);
		listePorte.add(po2);

		List<Integer>table3=new ArrayList<Integer>();
		for (int i = 0; i<rd.nextInt(this.listeMonstre.size());i++) {
			table3.add(rd.nextInt(this.listeMonstre.size()-3));
		}
		Salle salle3 = new Salle(1,1,false, table3);
		Porte po3= new Porte(true,salle3,salle2);

		listePorte.add(po3);
		List<Integer>table4=new ArrayList<Integer>();
		for (int i = 0; i<rd.nextInt(this.listeMonstre.size());i++) {
			table4.add(rd.nextInt(this.listeMonstre.size()-3));
		}
		Salle salle4 = new Salle(2,0,false, table4);
		Porte po4= new Porte(true,salle4,salle1);
		listePorte.add(po4);

		List<Integer>table5=new ArrayList<Integer>();
		for (int i = 0; i<2;i++) {
			table5.add(listeMonstre.size()-2+i);
		}
		Salle salle5 = new Salle(2,1,true, table5);
		Porte po5= new Porte(true,salle4,salle5);
		listePorte.add(po5);


		Porte po6= new Porte(true,salle5,salle3);
		listePorte.add(po6);

	}
	public void test(int nb){
		int nbSalle =nb;
		Arme arme=new Arme("Epee en bois",5,10,2);
		listeArme.add(arme);
		Arme arme1=new Arme("Epee en acier",15,10,4);
		listeArme.add(arme1);
		Arme arme2=new Arme("Epee en acier solide",25,20,4);
		listeArme.add(arme2);
		Arme arme3=new Arme("Epee de cristal",30,5,7);
		listeArme.add(arme3);
		Arme arme4=new Arme("Lame Blanche",200,30,10);
		listeArme.add(arme4);

		Armure armure1=new Armure("armure de cuir",10,10,5);
		listeArmure.add(armure1);
		Armure armure=new Armure("armure en papier",5,5,2);
		listeArmure.add(armure);
		Armure armure2=new Armure("armure de fer",30,10,5);
		listeArmure.add(armure2);
		Armure armure3=new Armure("Le kevlar",150,15,8);
		listeArmure.add(armure3);

		Personnage perso=new Personnage("Aramis",10,1);
		listePersonnage.add(perso);
		Personnage perso2=new Personnage("Boromis",8,2);
		listePersonnage.add(perso2);

		Monstre mons = new Monstre("pantin en bois",5, 1);
		this.listeMonstre.add(mons);
		mons=new Monstre("araignee geante agressive",7, 2);
		this.listeMonstre.add(mons);
		mons=new Monstre("Golem de Sable",20, 3);
		this.listeMonstre.add(mons);
		mons=new Monstre("Petit dragon",20,5);
		this.listeMonstre.add(mons);
		mons=new Monstre("Grand Dragon",40,5);
		this.listeMonstre.add(mons);
		mons=new Monstre("Chat sauvage",9, 1);
		this.listeMonstre.add(mons);
		mons= new Monstre("araignee geante agressive", 7, 5);
		this.listeMonstre.add(mons);
		mons=new Monstre("pantin de fer",20,1);
		this.listeMonstre.add(mons);
		mons = new Monstre("Golem de Jade",40, 3);
		this.listeMonstre.add(mons);
		mons= new Monstre("Neltharion le Gardeterre",100,10);
		this.listeMonstre.add(mons);
		mons = new Monstre("Neltharion, le Destructeur", 80,20);
		this.listeMonstre.add(mons);

		Marche marche = new Marche();
		List<Salle> ListSalle=new ArrayList<Salle>();
		ListSalle.add(marche);
		List<Integer>table;
		Salle salle;
		Salle deRelais;
		Porte porte;
		boolean ok=true;
		Random rd= new Random();
		table= new ArrayList<Integer>();
		table.add(0);
		table.add(1);
		salle=new Salle(0,1,false,table);
		ListSalle.add(salle);
		porte=new Porte(true,marche,salle);
		listePorte.add(porte);
		salle=new Salle(0,-1,false,table);
		ListSalle.add(salle);
		porte= new Porte(true, marche, salle);
		listePorte.add(porte);
		salle=new Salle(1,0,false,table);
		ListSalle.add(salle);
		listePorte.add(porte);
		for (int i = 0; i < nbSalle-4;i++) {
			table= new ArrayList<Integer>();
			for (int j = 0; j<rd.nextInt(4);j++) {
				table.add(rd.nextInt(this.listeMonstre.size()-3));
			}
			deRelais=ListSalle.get(rd.nextInt(ListSalle.size()));
			if(rd.nextInt(1)==0) {
				salle=new Salle( deRelais.getCoordonnes().getKey()+puissance(-1, rd.nextInt(1)),deRelais.getCoordonnes().getValue() ,false,table);
			} else {
				salle=new Salle( deRelais.getCoordonnes().getKey(),deRelais.getCoordonnes().getValue()+puissance(-1, rd.nextInt(1)) ,false,table);
			}
			if (ListSalle.contains(salle)) {
				nbSalle++;
				break;
			}
			else {
				ListSalle.add(salle);
				porte=new Porte(false, deRelais, salle);
				listePorte.add(porte);
			}
		}
		while (ok) {
			table= new ArrayList<Integer>();
			for (int j = 0; j<2;j++) {
				table.add(this.listeMonstre.size()-2+j);
			}
			deRelais=ListSalle.get(rd.nextInt(ListSalle.size()));
			if(rd.nextInt(1)==0) {
				salle=new Salle( deRelais.getCoordonnes().getKey()+puissance(-1, rd.nextInt(1)),deRelais.getCoordonnes().getValue() ,false,table);
			} else {
				salle=new Salle( deRelais.getCoordonnes().getKey(),deRelais.getCoordonnes().getValue()+puissance(-1, rd.nextInt(1)) ,false,table);
			}
			if (ListSalle.contains(salle))	ok = true;
			else {
				porte=new Porte(false, deRelais, salle);
				listePorte.add(porte);
				ok= false;
			}
		}
	
	}

	public static int puissance(int a, int p)
	{
		int result = 1;

		for(int i = 0; i < p; i++)
		{
			result = result * a;
		}

		return(result);
	}
	public void restore() {
		Random rd =new Random();
		for (Porte p : listePorte) {
			if (p.getSalle1().estVide() && !p.getSalle1().getType().contentEquals("Marche")) {
				for (int i =0; i<rd.nextInt(4);i++) {
					p.getSalle1().getListeEnnemie().add(rd.nextInt(listeMonstre.size()-3));
				}
			}
			if (p.getSalle1().estVide() && !p.getSalle1().getType().contentEquals("Marche")) {
				for (int i =0; i<rd.nextInt(4);i++) {
					p.getSalle1().getListeEnnemie().add(rd.nextInt(listeMonstre.size()-3));
				}
			}
		}
	}
}
